/************************************************************************/
/*                                                                      */
/*    *****                       *****                                 */
/*      *****                   *****                                   */
/*        *****               *****                                     */
/*          *****           *****                                       */
/*  ***************       ***************                               */
/*  *****************   *****************                               */
/*  ***************       ***************                               */
/*          *****           *****           TheNetNode                  */
/*        *****               *****         Portable                    */
/*      *****                   *****       Network                     */
/*    *****                       *****     Software                    */
/*                                                                      */
/* File os/linux/ax25ip.h (maintained by: DG9OBU)                       */
/*                                                                      */
/* This file is part of "TheNetNode" - Software Package                 */
/*                                                                      */
/* Copyright (C) 1998 - 2004 NORD><LINK e.V. Braunschweig               */
/*                                                                      */
/* This program is free software; you can redistribute it and/or modify */
/* it under the terms of the NORD><LINK ALAS (Allgemeine Lizenz fuer    */
/* Amateurfunk Software) as published by Hans Georg Giese (DF2AU)       */
/* on 13/Oct/1992; either version 1, or (at your option) any later      */
/* version.                                                             */
/*                                                                      */
/* This program is distributed WITHOUT ANY WARRANTY only for further    */
/* development and learning purposes. See the ALAS (Allgemeine Lizenz   */
/* fuer Amateurfunk Software).                                          */
/*                                                                      */
/* You should have received a copy of the NORD><LINK ALAS (Allgemeine   */
/* Lizenz fuer Amateurfunk Software) along with this program; if not,   */
/* write to NORD><LINK e.V., Hinter dem Berge 5, D-38108 Braunschweig   */
/*                                                                      */
/* Dieses Programm ist PUBLIC DOMAIN, mit den Einschraenkungen durch    */
/* die ALAS (Allgemeine Lizenz fuer Amateurfunk Software), entweder     */
/* Version 1, veroeffentlicht von Hans Georg Giese (DF2AU),             */
/* am 13.Oct.1992, oder (wenn gewuenscht) jede spaetere Version.        */
/*                                                                      */
/* Dieses Programm wird unter Haftungsausschluss vertrieben, aus-       */
/* schliesslich fuer Weiterentwicklungs- und Lehrzwecke. Naeheres       */
/* koennen Sie der ALAS (Allgemeine Lizenz fuer Amateurfunk Software)   */
/* entnehmen.                                                           */
/*                                                                      */
/* Sollte dieser Software keine ALAS (Allgemeine Lizenz fuer Amateur-   */
/* funk Software) beigelegen haben, wenden Sie sich bitte an            */
/* NORD><LINK e.V., Hinter dem Berge 5, D-38108 Braunschweig            */
/*                                                                      */
/************************************************************************/

/* Defines */
#define NO_MODE  0
#define IP_MODE  1
#define UDP_MODE 2
#define IPPROTO_AX25 93
#define DEFAULT_UDP_PORT 10093
#define CONFIG_FILE "ax25ip.cfg"
#define NOT_LAST(p)     (((*(p+6))&0x01)==0)
#define NOTREPEATED(p)  (((*(p+6))&0x80)==0)
#define NO_DIGIS(f)     (((*(f+13))&0x01)!=0)
#define MAX_FRAME  2048
#define TABLE_SIZE  128
#define LOGL1 if(loglevel>0)(void)write_log
#define LOGL2 if(loglevel>1)(void)write_log
#define LOGL3 if(loglevel>2)(void)write_log
#define LOGL4 if(loglevel>3)(void)write_log

/* Timeout fuer gelernte Routen (Sekunden) */
#ifdef AX25IP_DYNLEARN
static unsigned int uDynTimeout = 3600; /* eine Stunde */
#endif

/* Variablen */
static LHEAD  *l2flp;
static DEVICE *l1pp;
static int     ax25ip_port;
static BOOLEAN ax25ip_active = FALSE;
static BOOLEAN sockopt_keepalive = FALSE;
static BOOLEAN sockopt_throughput = FALSE;
static WORD    mode;
static struct  sockaddr_in udpbind;
static struct  sockaddr_in ipbind;
static struct  sockaddr_in to;
static struct  sockaddr_in from;
unsigned short my_udp = 0;
int            route_tbl_top = 0;
int            loglevel = 0;

int            fd_udp = -1;             /* Filedescriptor fuer UDP */
int            fd_ip = -1;              /* Filedescriptor fuer IP  */

/* TEST DG9OBU */
static BOOLEAN new_parser = FALSE;      /* Standardmaessig alte Syntax */

struct route_table_entry {
   unsigned char callsign[7];           /* the callsign and ssid */
   unsigned char padcall;               /* always set to zero */
   unsigned char ip_addr[4];            /* the IP address */
   unsigned short udp_port;             /* the port number if udp */
/* TEST DG9OBU */
#ifdef AX25IP_DYNLEARN
   unsigned int timeout;                /* Timeout der Route */
#endif
   unsigned char pad1;
   unsigned char pad2;
};

struct route_table_entry route_tbl[TABLE_SIZE];
struct route_table_entry default_route;

/* Funktionsprototypen */
int                setup_ip(void);
int                setup_udp(unsigned short);
void               show_rt_entry(struct route_table_entry rp, MBHEAD *bufpoi);
void               ccpaxipr(void);
void               ax25ip_send(void);
void               ax25ip_recv(void);
void               ax25ip_check_up(void);
void               ax25ip_check_down(void);
static void        route_add(unsigned char *, unsigned char *, int, int, int);
BOOLEAN            route_del(unsigned char *);
unsigned int       count_routes(BOOLEAN);
void               route_init(void);
/* TEST DG9OBU */
#ifdef AX25IP_DYNLEARN
void               route_age(void);
BOOLEAN            route_canlearn(MBHEAD*);
#endif
void               add_crc(unsigned char *buf, int l);
int                addrmatch(unsigned char *a, unsigned char *b);
void               add_ax25crc(unsigned char *buf, int l);
unsigned short int compute_crc(unsigned char *buf, int l);
int                config_read(void);
int                parse_line(char *buf);
int                a_to_call(char *text, unsigned char *tcall);
char              *call_to_a(unsigned char *tcall);
unsigned char     *call_to_ip(unsigned char *call);
unsigned char     *next_addr(unsigned char *f);
void               write_log(const char *format, ...);
int                ok_crc(unsigned char *buf, int l);

/* End */
